package com.suse.test;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.TableEditor;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.ui.part.ViewPart;

public class View extends ViewPart {
	public static final String ID = "SUSETest.view";
	
	/**
	 * This is a callback that will allow us to create the viewer and initialize
	 * it.
	 */
	public void createPartControl(Composite parent) {
		final Table sample = new Table(parent, SWT.FULL_SELECTION | SWT.HIDE_SELECTION);
		sample.setHeaderVisible(true);
		sample.setLinesVisible(true);
		
		TableColumn col1 = new TableColumn(sample, SWT.LEFT);
	    TableColumn col2 = new TableColumn(sample, SWT.LEFT);
	    
	    col1.setText("Column 1");
	    col2.setText("Column 2");
	    
	    col1.setWidth(100);
	    col2.setWidth(100);
	    
	    TableItem item1 = new TableItem(sample, SWT.NONE);
	    item1.setText(new String[]{"",""});
	    
	    item1 = new TableItem(sample, SWT.NONE);
	    item1.setText(new String[]{"",""});
	    
	    final TableEditor editor = new TableEditor(sample);
	    //The editor must have the same size as the cell and must
        //not be any smaller than 50 pixels.
        editor.horizontalAlignment = SWT.LEFT;
        editor.grabHorizontal = true;
        editor.minimumWidth = 50;
        // editing the second column
        final int EDITABLECOLUMN1 = 0;
        final int EDITABLECOLUMN2 = 1;
	    sample.addSelectionListener(new SelectionListener(){

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void widgetSelected(SelectionEvent e) {
				 // Clean up any previous editor control
                Control oldEditor = editor.getEditor();
                if (oldEditor != null) oldEditor.dispose();

                // Identify the selected row
                TableItem item = (TableItem)e.item;
                if (item == null) return;
                String col1Text = item.getText(EDITABLECOLUMN1);
                if("".equals(col1Text)){
                	// The control that will be the editor must be a child of the Table
                    Combo newEditor = new Combo(sample, SWT.NONE);
                    newEditor.add("option1");
                    newEditor.add("option2");
                    newEditor.add("option3");
                    
                    newEditor.setText(item.getText(EDITABLECOLUMN1));
                    newEditor.addModifyListener(new ModifyListener() {
                        public void modifyText(ModifyEvent e) {
                    		Combo text = (Combo)editor.getEditor();
                            editor.getItem().setText(EDITABLECOLUMN1, text.getText());
                        }
                    });
                    newEditor.setFocus();
                    editor.setEditor(newEditor, item, EDITABLECOLUMN1);
                } else {
                	// The control that will be the editor must be a child of the Table
                    Combo newEditor = new Combo(sample, SWT.NONE);
                    newEditor.add(col1Text+"-1");
                    newEditor.add(col1Text+"-2");
                    newEditor.add(col1Text+"-3");
                    
                    newEditor.setText(item.getText(EDITABLECOLUMN2));
                    newEditor.addModifyListener(new ModifyListener() {
                        public void modifyText(ModifyEvent e) {
                    		Combo text = (Combo)editor.getEditor();
                            editor.getItem().setText(EDITABLECOLUMN2, text.getText());
                        }
                    });
                    newEditor.setFocus();
                    editor.setEditor(newEditor, item, EDITABLECOLUMN2);
                }
			}
	    });
	}

	/**
	 * Passing the focus request to the viewer's control.
	 */
	public void setFocus() {
	}
}